package be.iminds.ilabt.jfed.experiment.tasks;

import be.iminds.ilabt.jfed.call_log_output.LogOutput;

/**
 * User: twalcari
 * Date: 11/23/2015
 * Time: 16:34
 */
public enum ExperimentTaskStatus {
    INACTIVE(1), BUSY(2), SUCCESS(0), FAILED(10), WARNING(8);

    final int graveness;

    ExperimentTaskStatus(int graveness) {
        this.graveness = graveness;
    }

    /**
     * @param a
     * @param b
     * @return the "worst" state of the two. Failure takes priority over warning, then busy, then inactive, then success.
     */
    public static ExperimentTaskStatus worstOf(ExperimentTaskStatus a, ExperimentTaskStatus b) {
        if (a.graveness > b.graveness)
            return a;
        else
            return b;
    }

    public LogOutput.TestResultState toTestResultState() {
        switch (this) {
            case FAILED: return LogOutput.TestResultState.FAILED;
            case SUCCESS: return LogOutput.TestResultState.SUCCESS;
            case WARNING: return LogOutput.TestResultState.WARN;
            default:
            case BUSY:
            case INACTIVE: throw new RuntimeException("Cannot convert "+this+" to any LogOutput.TestResultState");
        }
    }
}
